#!/usr/bin/bash
DIR=./LEAR_Temp
if [ -d "$DIR" ];
then
	echo "Folder $DIR exists"
	echo "Contents deleted..."
	rm $DIR/* > NULL
else
	echo "Folder $DIR does not exist"
	echo "Creating folder..."
	mkdir $DIR
	echo "Folder created"
fi

echo "Launching converter"
cp ./learmonth.py $DIR
cp ./generationFits.py $DIR
cp $1 $DIR
cd $DIR
echo "Input file: " "$1"

./learmonth.py $1

FICH=$(ls samples*.txt | wc -l)
let FICH=$FICH-1
echo "Generating FIT files. Please wait..."
contador=0
while [ $FICH -gt $contador ]
do
	#echo $contador
	cp samples_"$contador".txt samples.txt
	cp header_times_"$contador".txt header_times.txt
	./generationFits.py LEARMONTH 01
	let contador=$contador+1
done
fecha=$(ls *.fit | cut -c 11-18 | tail -1)
echo "Compressing FIT files into zip file"
zip -q LEARMONTH_"$fecha".zip *.fit
echo "Process finished"
