#!/usr/bin/python3
##### PROCESADO DE FICHEROS SRS DE LEARMONTH ####
# M. Prieto. Feb. 2023. Universidad de Alcala (Spain)
#Paso 1. Abrir fichero
import sys
import struct

n=len(sys.argv)
if n<2:
        print ("Sintax:")
        print ("./learmonth.py learmonth_input_file (.srs)")
        exit()
#print (n)
myfile=sys.argv[1]
f1=open(myfile,"rb")
print ("Learmonth SRS file opened")
#Paso 2. Mostrar informacion del fichero
#print ("Header")
data_header=f1.read(8)
print("Year = ", data_header[0])
print("Month = ", data_header[1])
print("Day = ", data_header[2])
print("Hour = ", data_header[3])
print("Minute = ", data_header[4])
print("Second = ", data_header[5])
#print ("Channel header")
linea1="20"+str(data_header[0])+"/"+"{:0>2}".format(str(data_header[1]))+"/"+"{:0>2}".format(str(data_header[2]))+"\n"
linea2="{:0>2}".format(str(data_header[3]))+":"+"{:0>2}".format(str(data_header[4]))+":"+"{:0>2}".format(str(data_header[5]))+"\n"
#start_freq=struct.unpack(">H",f1.read(2))
#print("Start Frequency (MHz) = ", start_freq)
start_freq1=int.from_bytes(f1.read(2),"big")
print("Start Frequency CH1 (MHz) = ", start_freq1)
end_freq1=int.from_bytes(f1.read(2),"big")
print("End Frequency CH1 (MHz) = ", end_freq1)
#el resto de campos no me interesan. Posiciono cursor en inicio de datos
f1.read(4)
start_freq2=int.from_bytes(f1.read(2),"big")
print("Start Frequency CH2 (MHz) = ", start_freq2)
end_freq2=int.from_bytes(f1.read(2),"big")
print("End Frequency CH2 (MHz) = ", end_freq2)
f1.read(4)
#paso 3. Genero fichero de frecuencias
f3=open("frequencies.txt","w")
rango_frecuencias=end_freq2-start_freq1
paso=rango_frecuencias/802
freq=start_freq1
frecuencia=0
for i in range (0,802):
	frecuencia=freq
	frecuencia="{:.6f}".format(frecuencia)
	f3.write(str(frecuencia)+"\n")
	freq=freq+paso

#print ("Fichero de frecuencias creado")
f3.close()
#paso 4. Generar fichero de tiempos
f4=open("times.txt","w")
tiempo=0
for i in range (0,300):
	f4.write(str(tiempo)+"\n")
	tiempo=tiempo+3
#print ("Fichero de tiempos creado")
f4.close()
#paso 5
scan=0
num_fits=0
final_fichero=0
while final_fichero==0:
	f2=open("samples_"+str(num_fits)+".txt","w")
	f6=open("header_times_"+str(num_fits)+".txt","w")
	f6.write(linea1)
	f6.write(linea2)

	while scan<300:
		#Leer datos
		for i in range (0,802):
			amp_ch12=int.from_bytes(f1.read(1),"big")
			f2.write(str(amp_ch12)+"\n")
		scan=scan+1
		#print("Muestreo = ",scan)
		data_header=f1.read(8)
		if not data_header:
			print ("End of file")
			final_fichero=1
			break
		#data_header=f1.read(7)
		ch1_header=f1.read(8)
		ch2_header=f1.read(8)

	if (final_fichero==0):
		linea3="20"+str(data_header[0])+"/"+"{:0>2}".format(str(data_header[1]))+"/"+"{:0>2}".format(str(data_header[2]))+"\n"
		linea4="{:0>2}".format(str(data_header[3]))+":"+"{:0>2}".format(str(data_header[4]))+":"+"{:0>2}".format(str(data_header[5]))+"\n"
		#print (linea3)
		#print (linea4)
		f6.write(linea3)
		f6.write(linea4)
		f6.write("44660")
		linea1=linea3
		linea2=linea4
	f6.close()
	f2.close()
	num_fits=num_fits+1;
	scan=0;

#FINAL. Cerramos fichero
#print ("Numero de muestreos de 3 segundos:", scan)
print ("Total 15-minute FIT files:", num_fits)
f1.close()
#f2.close()
print ("Learmonth file closed")
#print ("Fichero de muestras cerrado")
